package org.synbiowave.translate;

import java.util.Vector;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.menu.MenuItemFactory;
import org.synbiowave.menu.items.Formular;
import org.synbiowave.translate.menucallbacks.TranslationCallBack;
import org.synbiowave.utils.SequenceColorUtils;

import com.google.wave.api.Blip;
import com.google.wave.api.Context;
import com.google.wave.api.Gadget;
import com.google.wave.api.event.Event;
import com.google.wave.api.event.GadgetStateChangedEvent;
import com.google.wave.api.event.WaveletSelfAddedEvent;
/**
 * This is the meat of the robot, This extends the main robot(Synbiowave)
 * and inserts the menu for translation in the original menu
 * @author paradkap
 *
 */
public class TranslationServlet extends AbstractSynBioWaveRobot {

	// private static final long serialVersionUID = -3637163605622939073L;

	// Constructor of Robot, set the authentication parameters
	public TranslationServlet() {
		super.setupOAuth("593171839091", "ICSC5wJEqCkJMTpcvjgpjXW0",
				"http://gmodules.com/api/rpc");
		super.setupOAuth("593171839091", "ICSC5wJEqCkJMTpcvjgpjXW0",
				"http://sandbox.gmodules.com/api/rpc");
		super.setAllowUnsignedRequests(true);
	}

	@Override
	protected String getRobotName() {
		return "Translation Robot";
	}

	@Override
	protected String getRobotAvatarUrl() {
		return "http://2010.igem.org/wiki/images/8/80/Freiburg_10_software_Icon_T.png";
	}

	@Override
	protected String getRobotProfilePageUrl() {
		return "http://www.SynBioWave.org";
	}

	@Override
	public void onWaveletSelfAdded(WaveletSelfAddedEvent event) {
		super.onSynBioWaveRobotSelfAdded(event);
	}

	@Capability(contexts = { Context.ALL })
	@Override
	public void onGadgetStateChanged(GadgetStateChangedEvent event) {
		super.onSynBioWaveGadgetChanged(event);
	}

	// creates the menu of the translation and inserts in the main menu 
	// and sets the callback for menu operations
	@Override
	public void createMenu(MenuItem menu, MenuItemFactory mif, Event event)
			throws Exception {
		MenuItem sequenceMenu = mif.createMenu("Translate");
		sequenceMenu.setOption("sort", "10");
		menu.appendSubItem(sequenceMenu);

		Formular mainMenu = mif.createForm("ORF Parameters", "Set Parameters:");
		mainMenu.addInputfield("Frame Number:(1..6, 0 for all)", "0", "order");
		mainMenu.addInputfield("Minimum ORF Length:", "0", "order");

		sequenceMenu.appendSubItem(mainMenu);
		super.connectMenuCallBack(mainMenu, new TranslationCallBack());
	}



//	  public void showGadgetViewVec(Blip blip, String name, String sequence,Vector<Integer> start,Vector<Integer> end)
//	  {
//		  String htmlViewSequences = SequenceColorUtils.getHTMLView(sequence,start,end);
//		    String names = "(br /)(br /)(br /)" + name;
//		    Gadget seqView = new Gadget("http://samnode.de/SequenceView.xml");
//		    seqView.setProperty("names", names + "(br /)(br /)");
//		    seqView.setProperty("sequences", htmlViewSequences);
//		    blip.append(seqView);
//	  }

}